/**
 * This example shows how to display a simple component a simple text inside ES
 * 
 * The system expects a variable called with the name as the plugin (here 'HelloWorld').
 * This variable is an object that MUST contain the two mandatory functions: 
 * - buildComponent
 * - update
 */
var HelloWorld = {
  buildComponent: function() {
    var component = document.createElement('h1');
    component.textContent = 'Hello, World!';

    // The buildComponent function MUST return a value amongst these three types:
    // - An ExtJs 3.4 component
    // - A HTML Element (like here.)
    // - or a string that can be interpreted as an HTML string
    return component;
  },

  update: function() {
    // Nothing to do...
  } 
};
