var AdvancedMetaData = {
  buildComponent: function() {
    var container = document.createElement('div');
    
    // button '+'
    var addRowButton = document.createElement('button');
    addRowButton.value = 'Add row';
    addRowButton.onclick = function() {
      this.table.appendChild(this.createRow());
    }.bind(this);

    this.table = document.createElement('table');
    
    container.appendChild(addRowButton);
    container.appendChild(this.table);
    return container;
  },

  update: function() {
    var data = [
      this.getModelProperty("MetaData/:demo/Metadata1"),
      this.getModelProperty("MetaData/:demo/Metadata2"),
      this.getModelProperty("MetaData/:demo/Metadata3"),
    ];
    this.table.getElementsByTagName('td').forEach((elem, index) => {
      elem.textContent = data[index];
    });
  },

  createRow: function() {
    var row = document.createElement('tr');
    var col1 = document.createElement('td');
    var col2 = document.createElement('td');
    var col3 = document.createElement('td');
    row.appendChild(col1);
    row.appendChild(col2);
    row.appendChild(col3);

    var select = this.createSelect();
    select.onchange = function() {
      col2.textContent = this.getModelProperty(select.value);
    }.bind(this);

    var removeRowButton = document.createElement('button');
    removeRowButton.value = 'Remove';
    removeRowButton.onclick = function() {
      this.table.removeChild(row);
    }.bind(this);

    return row;
  },

  createSelect: function() {
    var select = document.createElement('select');
    
    var opt1 = document.createElement('option');
    opt1.value = "MetaData/:demo/Metadata1";
    opt1.text = "Metadata1"

    var opt2 = document.createElement('option');
    opt2.value = "MetaData/:demo/Metadata2";
    opt2.text = "Metadata2"

    var opt3 = document.createElement('option');
    opt3.value = "MetaData/:demo/Metadata3";
    opt3.text = "Metadata3"

    select.appendChild(opt1);
    select.appendChild(opt2);
    select.appendChild(opt3);

    return select;
  }
};
