var Structure = {
    getStruct: function() {
        var struct = {};
        try {
            console.log(this.getModelProperty("MetaData/:demo/Struct"));
            var value = this.getModelProperty("MetaData/:demo/Struct");
            if (typeof value === 'string') {
                struct = JSON.parse(value);
            } else {
                struct = value || {};
            }
        } catch (e) {
            struct = {};
        }
        return struct;
    },

    initModel: function() {
        this.model = {};
        this.elems = {};
        this.model.struct = this.getStruct();
        this.model.cols = [
            'demo:Metadata1',
            'demo:Metadata2',
            'demo:Metadata3',
            'demo:Metadata4'
        ];
    },

    buildComponent: function() {
        this.initModel();

        // Container (div that contains the whole plugin)
        var $container = document.createElement('div');

        // Table
        var $table = this.createTable();
        $container.appendChild($table);

        return $container;
    },

    update: function() {
        this.model.struct = this.getStruct();
        this.fillTable();
    },

    createTable: function() {
        var $table = document.createElement('table');
        this.elems.$table = $table;

        var $header = document.createElement('tr');
        this.model.cols.forEach(function(value) {
            var $th = document.createElement('th');
            $th.textContent = value;
            $header.appendChild($th);
        }, this);
        $header.appendChild(document.createElement('th'));
        $table.appendChild($header);

        this.fillTable();

        return $table;
    },

    fillTable: function() {
        // Empty the table, except for the header row
        while (this.elems.$table.childElementCount > 1) {
            this.elems.$table.removeChild(this.elems.$table.lastChild);
        }

        // Add rows
        this.addRow();
    },

    addRow: function() {
        // Row
        var $row = document.createElement('tr');

        var that = this;
        this.model.cols.forEach(function(col) {
            var $col = document.createElement('td');
            var $input = document.createElement('input');
            $input.placeholder = 'Set a value';
            $input.value = that.model.struct[col] || '';

            $input.addEventListener('change', function() {
                that.model.struct[col] = $input.value;
                that.setModelProperty("MetaData/:demo/Struct", JSON.stringify(that.model.struct));
            });

            $col.appendChild($input);
            $row.appendChild($col);
        });
        this.elems.$table.appendChild($row);

        return $row;
    },
};